-module(filecopy).

-define(DRV, sample_drv).
-define(BUFSIZ, 8192).

-export([copy/2]).

copy(Src, Dst) ->
    {ok, Port} = ?DRV:start(),
    {ok, SrcF} = ?DRV:fopen(Port, Src, "r"),
    {ok, DstF} = ?DRV:fopen(Port, Dst, "w"),
    {ok, Buf} = ?DRV:malloc(Port, ?BUFSIZ),
    RFun = fun () -> 
      ?DRV:fread(Port, Buf, 1, ?BUFSIZ, SrcF) end,
    WFun = fun (N) ->
      ?DRV:fwrite(Port, Buf, N, DstF) end,
    Val = copy2(RFun, WFun),
    %% Shutdown will automatically close
    %% files and free the buffer.
    ?DRV:shutdown(Port),
    Val.

copy2(RFun, WFun) ->
    copy2(RFun, WFun, RFun()).
copy2(RFun, WFun, {ok, N}) ->
    WFun(N),
    copy2(RFun, WFun);
copy2(RFun, WFun, {error, 0}) ->
    ok;                 % End of file
copy2(RFun, WFun, Error) ->
    Error.
