
#include <stdio.h>
#include <string.h>
#include <errno.h>

#include <sp.h>

#include <erl_driver.h>
#include <spread_drv.h>
#include <erl_driver_tk.h>

#include <my-spread.h>

#ifdef  DRIVER_USING_PTHREADS
#include <pthread.h>
static pthread_once_t _once = PTHREAD_ONCE_INIT;
#endif  /* DRIVER_USING_PTHREADS */

static int _initialized = 0;
/* QQQ unused: static ErlDrvTermData am_blar; */

static void init_my_atoms(void);

int
make_xret_group_list(struct descriptor *desc, callstate_t *c, ErlDrvTermData *msg,
		     int *members, int *msgcount)
{
    int         mycount = 0;
    int		i;
    char	*g, *bufp;
    int		g_len;

    if (! _initialized) {
#ifdef  DRIVER_USING_PTHREADS
        pthread_once(&_once, init_my_atoms);
#else   /* DRIVER_USING_PTHREADS */
        init_my_atoms();
#endif  /* DRIVER_USING_PTHREADS */

    }

    g = c->i.groups;
    for (i = 0; i < c->o.num_groups; i++, g += MAX_GROUP_NAME) {
	g_len = strlen(g);
	if ((bufp = edtk_driver_alloc_wrapper(g_len)) == NULL) {
	    /*
	    ** QQQ We're just screwed here, given the stuff we've already
	    ** pushed onto the stack.  I think our options are to:
	    ** 1. abort, or 2. return prematurely.  If we do #2, then
	    ** driver_output_term() will puke, then the Erlang receiver
	    ** will hang forever waiting for a reply ... but at least the
	    ** rest of the VM will have a chance to try to continue.
	    */
	    return 0;
	}
	memcpy(bufp, g, g_len);
	*msgcount = LOAD_BINARY(msg, *msgcount,
				edtk_alloced_ptr2ErlDrvBinary(bufp), 0, g_len);
	mycount++;
    }

    free(c->i.groups);		/* QQQ Ugly, but we've got to free it here */

    *msgcount = LOAD_NIL(msg, *msgcount);
    mycount++;

    *members = mycount;
    return 1;
}

static void
init_my_atoms(void)
{
    /* QQQ unused: am_blar = driver_mk_atom("blar"); */
    _initialized = 1;
}
